#from typing_extensions import Required
from rest_framework import serializers
from .models import *
#from django.utils import timezone
#from django.db.models import Max
############## Prescription%Module #################

class DrugSerializer(serializers.ModelSerializer):
    time_todo_name = serializers.CharField(source="time_todo.name",default="",read_only=True)
    class Meta:
        model = Drug
        fields="__all__"
class DrugMiniSerializer(serializers.ModelSerializer):
    class Meta:
        model = Drug
        fields=("name_en","name_ar","id","time_todo")
class RadiologySerializer(serializers.ModelSerializer):
    time_todo_name = serializers.CharField(source="time_todo.name",default="",read_only=True)
    class Meta:
        model = Radiology
        fields="__all__"
class MedicalTestSerializer(serializers.ModelSerializer):
    time_todo_name = serializers.CharField(source="time_todo.name",default="",read_only=True)
    class Meta:
        model = MedicalTest
        fields="__all__"

class TimeTodoSerializer(serializers.ModelSerializer):
    class Meta:
        model = TimeTodo
        fields="__all__"

class PresDrugItemSerializer(serializers.ModelSerializer):
    item_type_string = serializers.SerializerMethodField()
    item_type_model = serializers.SerializerMethodField()
    item_name_string = serializers.SerializerMethodField()
    todo_string = serializers.SerializerMethodField()
    
    class Meta:
        model = PresDrugItem
        fields="__all__"
        read_only_fields = ("item_type_string","item_type_model",'item_name_string', 'todo_string')

    def get_item_name_string(self, obj):
        return obj.drug.name_en
    def get_todo_string(self, obj):
        return obj.time_todo.name
    def get_item_type_string(self, obj):
        return "دواء"
    def get_item_type_model(self, obj):
        return "Drug"
    
class PresRadiologyItemSerializer(serializers.ModelSerializer):
    item_type_string = serializers.SerializerMethodField()
    item_type_model = serializers.SerializerMethodField()
    item_name_string = serializers.SerializerMethodField()
    todo_string = serializers.SerializerMethodField()

    class Meta:
        model = PresRadiologyItem
        fields="__all__"
        read_only_fields = ("item_type_string","item_type_model",'item_name_string', 'todo_string')

    def get_item_name_string(self, obj):
        return "{}".format(obj.radiology.name)
        #return "{} {} ".format(obj.radiology.name,obj.radiology.descrption)
    def get_todo_string(self, obj):
        return obj.time_todo.name
    def get_item_type_string(self,obj):
        return "أشعة"
    def get_item_type_model(self,obj):
        return "Radiology"
class PresTestItemSerializer(serializers.ModelSerializer):
    item_type_string = serializers.SerializerMethodField()
    item_type_model = serializers.SerializerMethodField()
    item_name_string = serializers.SerializerMethodField()
    todo_string = serializers.SerializerMethodField()

    class Meta:
        model = PresTestItem
        fields="__all__"
        read_only_fields = ("item_type_string","item_type_model",'item_name_string', 'todo_string')
    
    def get_item_name_string(self, obj):
        return "{}".format(obj.medical_test.name)
        #return "{} {} ".format(obj.medical_test.name,obj.medical_test.descrption)
    def get_todo_string(self, obj):
        return obj.time_todo.name
    def get_item_type_string(self,obj):
        return  "تحليل"
    def get_item_type_model(self,obj):
        return "Test"

############## END Prescription%Module #################